#! /usr/bin/perl
#Name: watchdog-lander-server.perl
#Project: LanderControl
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 03.01.2012
#Copyright: (c) 2011 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Script starts and observes the functionallity of lander-server.perl.

use strict;

use FindBin qw($Bin);


$SIG{'QUIT'} = 'interrupt';
$SIG{'INT' } = 'interrupt';
$SIG{'HUP' } = 'interrupt';
$SIG{'TRAP'} = 'interrupt';
$SIG{'ABRT'} = 'interrupt';
$SIG{'STOP'} = 'interrupt';


my $char_temp = "";
my @file_info;
my $current_timestamp = "";
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $CTIME_String = localtime(time);
my $wait_count = 0;
my $last_watchdog_call = 0;
my $file_server_status = "lander-connect.txt";
my $blocked_count = 0;


sub interrupt {#catch interrupt signals
  my($signal)=@_;
  &LogFile("Watchdog caught Interrupt\: $signal");
  print "Exiting program\n";
  `cp no_connection.jpg bild01.jpg`;
  &CopyIndicationPicture();
  exit(1);
}



  chdir("$Bin");

  &LogFile("!!! Watchdog lander started !!!");

  open(FILEOUT, ">" . $file_server_status) || die "Can not open file $file_server_status!\n";
    print FILEOUT "Restarting lander server.\n";
  close (FILEOUT);


  `killall -s SIGKILL lander-server.perl`;
  sleep(2);
  `rm watchdog.tmp`;
  `rm watchdog.txt`;
  print "Starting lander server.\n";
  system("./lander-server.perl&");
  sleep(2);
  print "Server started.\n";

  while(1 == 1){
    print "Checking...\n";
    if(!-e "watchdog.tmp"){#lander-server.perl is currently writing into file, so don't read timestamp now
      open(FILEIN, "< watchdog.txt") || die &LogFile("Watchdog: Can not open file watchdog.txt!");
        $current_timestamp = <FILEIN>;
      close(FILEIN);
      if($current_timestamp > 1){
        if(time() - $current_timestamp > 40){
          print "Time exceeded - killing lander server\n";
          &LogFile("Time limit exceeded!");
          `cp no_connection.jpg bild01.jpg`;
          `killall -s SIGKILL lander-server.perl`;
          open(FILEOUT, ">" . $file_server_status) || die &LogFile("Watchdog: Can not open file $file_server_status!");
            print FILEOUT "Restarting lander server.\n";
          close (FILEOUT);
          sleep(5);
          print "Starting lander server\n";
          system("./lander-server.perl&");
        }
        else{
          print "Time difference = " . (time()-$current_timestamp) . " ok.\n";
          $blocked_count = 0;
        }
      }
      else{
        print "current_timestamp = '$current_timestamp'\n"
      }
    }#if(-e "watchdog.tmp"){
    else{
      print "Currently blocked...\n";
      $blocked_count++;
      if($blocked_count > 5){
        `rm watchdog.tmp`;
        print "blocked_count > 2 - killing lander server\n";
        &LogFile("blocked_count > 2!");
        `cp no_connection.jpg bild01.jpg`;
        `killall -s SIGKILL lander-server.perl`;
        open(FILEOUT, ">" . $file_server_status) || die &LogFile("Watchdog: Can not open file $file_server_status!\n");
          print FILEOUT "Restarting lander server.\n";
        close (FILEOUT);
        sleep(5);
        print "Starting lander server\n";
        system("./lander-server.perl&");
      }
    }
    sleep(40);
  }#while(1){


#++++++++++++++++++++++ LogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("lander-server.log");


  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);

  if ($file_info[7] > 1000000){
    `mv lander-server.log lander-server01.log`
  }

  open(LOGFILE, ">> lander-server.log") || die "Can not open file 'lander-server.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}
